<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/*EXTRA FUNCTIONS: shell_exec*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		phpinfo
 */

/**
 * Module page class.
 */
class Module_admin_phpinfo
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		return $info;
	}

	/**
	 * Standard modular entry-point finder function.
	 *
	 * @return ?array	A map of entry points (type-code=>language-code) (NULL: disabled).
	 */
	function get_entry_points()
	{
		return array('!'=>'PHP_INFO');
	}

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	The result of execution.
	 */
	function run()
	{
		if (get_file_base()!=get_custom_file_base()) warn_exit(do_lang_tempcode('SHARED_INSTALL_PROHIBIT'));

		require_lang('menus');
		get_screen_title('PHP_INFO');
		$GLOBALS['SCREEN_TEMPLATE_CALLED']='';
		$GLOBALS['TITLE_CALLED']=true;

		require_lang('menus');
		$GLOBALS['HELPER_PANEL_TEXT']=comcode_lang_string('DOC_PHP_INFO');

		ob_start();
		phpinfo();
		require_code('xhtml');
		$out=xhtmlise_html(ob_get_contents());
		ob_end_clean();

		$out=preg_replace('#<!DOCTYPE[^>]*>#s','',preg_replace('#</body[^>]*>#','',preg_replace('#<body[^>]*>#','',preg_replace('#</html[^>]*>#','',preg_replace('#<html[^>]*>#','',$out)))));
		$matches=array();
		if (preg_match('#<style[^>]*>#',$out,$matches)!=0)
		{
			$offset=strpos($out,$matches[0])+strlen($matches[0]);
			$end=strpos($out,'</style>',$offset);
			if ($end!==false)
			{
				$style=substr($out,$offset-strlen($matches[0]),$end-$offset+strlen('</style>')+strlen($matches[0]));
				//$GLOBALS['EXTRA_HEAD']=make_string_tempcode($style);

				$out=substr($out,0,$offset).substr($out,$end);
			}
		}
		$out=preg_replace('#<head[^>]*>.*</head[^>]*>#s','',$out);

		$out=str_replace(' width="600"',' width="100%"',$out);
		//$out=preg_replace('#([^\s<>"\']{65}&[^;]+;)#','${1}<br />',$out);
		//$out=preg_replace('#([^\s<>"\']{95})#','${1}<br />',$out);
		$url_parts=parse_url(get_base_url());
		$out=str_replace('<img border="0" src="/','<img border="0" style="padding-top: 20px" src="http://'.escape_html($url_parts['host']).'/',$out);

		$out.='<h2>Run-time details</h2>';
		$out.='<p>Your IP address: '.escape_html(get_ip_address()).'</p>';
		if ((function_exists('posix_getpwuid')) && (strpos(@ini_get('disable_functions'),'posix_getpwuid')===false))
		{
			$user=posix_getuid();
			$suexec=($user==fileowner(get_file_base().'/index.php'));
			$dets=posix_getpwuid($user);
			$out.='<p>Running as user: '.escape_html($dets['name']).' ('.($suexec?'suEXEC or similar':'Not suEXEC').')</p>';
		}
		elseif (strpos(@ini_get('disable_functions'),'shell_exec')===false)
		{
			$test=shell_exec('whoami');
			if (!empty($test))
			{
				if (strpos(@ini_get('disable_functions'),'get_current_user')===false)
				{
					$suexec=($test==get_current_user());
				} else
				{
					$suexec=NULL;
				}
				$out.='<p>Running as user: '.escape_html($test).(is_null($suexec)?'':(' ('.($suexec?'suEXEC or similar':'Not suEXEC').')')).'</p>';
			}
		} else
		{
			$tmp=ocp_tempnam('');
			$user=@fileowner($tmp);
			@unlink($tmp);
			$suexec=($user==fileowner(get_file_base().'/index.php'));
			$out.='<p>Running as user: '.escape_html(($suexec && (strpos(@ini_get('disable_functions'),'get_current_user')===false))?get_current_user():('#'.strval($user))).' ('.($suexec?'suEXEC or similar':'Not suEXEC').')</p>';
		}
		$out.='<p>PHP configured as: '.escape_html(php_sapi_name()).'</p>';

		require_css('phpinfo');

		require_code('xhtml');
		$ret=make_string_tempcode(xhtmlise_html($out));
		return $ret;
	}

}


