<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		news
 */

class Hook_config_default_ping_url
{

	/**
	 * Gets the details relating to the config option.
	 *
	 * @return ?array		The details (NULL: disabled)
	 */
	function get_details()
	{
		return array(
			'human_name'=>'PING_URL',
			'the_type'=>'text',
			'the_page'=>'FEATURE',
			'section'=>'NEWS_AND_RSS',
			'explanation'=>'CONFIG_OPTION_ping_url',
			'shared_hosting_restricted'=>'0',
			'c_data'=>'',

			'addon'=>'news',
		);
	}

	/**
	 * Gets the default value for the config option.
	 *
	 * @return ?string		The default value (NULL: option is disabled)
	 */
	function get_default()
	{
		// http://blogsearch.google.com/ping?url={url} is the direct Google Blog search one
		// Note that we also ping the major search engines directly with the RSS feed, as a sitemap; those do not need specifying in the ping URLs
		return 'http://pingomatic.com/ping/?title={title}&blogurl={url}&rssurl={rss}';
	}

}


