<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core
 */

class Hook_cron_sitemap
{

	/**
	 * Standard modular run function for CRON hooks. Searches for tasks to perform.
	 */
	function run()
	{
		if (!is_guest()) return; // Bad idea

		$time=time();
		$last_time=intval(get_value('last_sitemap_time_calc'));

		if (get_value('sitemap_building_in_progress')=='1' && intval(get_value('last_sitemap_time_calc'))>time()-60*60*24*3/*in case it stalled a few days back - force a re-try*/) return;

		if ($last_time>time()-60*60*24) return; // Every day

		set_value('sitemap_building_in_progress','1');

		set_value('last_sitemap_time_calc',strval($time));

		require_code('sitemap');
		sitemaps_build();

		set_value('sitemap_building_in_progress','0');
	}

}


