<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		calendar
 */

class Hook_Preview_calendar_type
{

	/**
	 * Find whether this preview hook applies.
	 *
	 * @return array			Triplet: Whether it applies, the attachment ID type, whether the forum DB is used [optional]
	 */
	function applies()
	{
		$applies=(get_param('page','')=='cms_calendar') && ((get_param('type','')=='ac') || (get_param('type','')=='_ec'));
		return array($applies,NULL,false);
	}

	/**
	 * Standard modular run function for preview hooks.
	 *
	 * @return array			A pair: The preview, the updated post Comcode
	 */
	function run()
	{
		require_code('uploads');

		$urls=get_url('','file','safe_mode_temp',0,OCP_UPLOAD_IMAGE,false);
		if ($urls[0]=='')
		{
			if (!is_null(post_param_integer('id',NULL)))
			{
				$rows=$GLOBALS['SITE_DB']->query_select('calendar_types',array('t_logo'),array('id'=>post_param_integer('id')),'',1);
				$urls=$rows[0];

				$url=find_theme_image($urls['t_logo']);
			} elseif (!is_null(post_param('theme_img_code',NULL)))
			{
				$url=find_theme_image(post_param('theme_img_code'));
			} else
			{
				warn_exit(do_lang_tempcode('IMPROPERLY_FILLED_IN_UPLOAD'));
			}
		} else
		{
			$url=$urls[0];
		}

		require_code('images');
		$preview=do_image_thumb(url_is_local($url)?(get_custom_base_url().'/'.$url):$url,post_param('title'),true);

		return array($preview,NULL);
	}

}
